/*==========================================================================
		lcd.c
----------------------------------------------------------------------------
		LCD𓮂߂̊{vOB

		LCDFSC1602BS*B, 16~2s, 5V쓮
		샂[hF4bit
		^[QbgFdsPIC

		dsPICLCD̃|[g̑Ή֌W
	   [dsPIC]    [LCD]
		RB5--------DB7 f[^
		RB4--------DB6 f[^
		RB3--------DB5 f[^
		RB2--------DB4 f[^
		RB1--------RS  f[^/߃WX^I H:f[^,L:
		RB0--------E   Cl[u
===========================================================================*/

#include <p30f5011.h>	//vZbTwb_t@C,TRISBPORTB`Ă
#include "lcd.h"		//lcd.c̊֐̃vg^Cv錾

#define		LCD_RS	0x02	//RS:'H'x
#define		LCD_E	0x01	//E :'H'x

/*==========================================================================
	@@@@@@@@@@@@WAIT  ԒP[ms]
----------------------------------------------------------------------------
	fosc = 7.37[MHz] dsPIC̓NbNgp
	fsy  = 7.37 * 8 = 58.96[MHz] PLLx8gp
	fcy  = 58.96 / 4 = 14.74[MIPS]
===========================================================================*/
void wait(unsigned int c)
{
	unsigned int	i=2106,j;
	for(j=0;j<c;j++)
	{
		while(--i);	//i̒l21060ɂȂƂ1ms
		i=2106;
	}
}

/*==========================================================================
							LCD o(8bit)	
----------------------------------------------------------------------------
@̂ݎgpB8rbgf[^̂A4rbgo͂B
==========================================================================*/
void LCDOut8(int rs, char code)
{
	char	mode;	//݃[h

	if( rs )	mode = LCD_RS;	//f[^
	else		mode = 0x00;	//

	PORTB = mode;								//RSo
	PORTB = ((code>>2)&0x3c) | mode | LCD_E;	//RS,E,f[^o
	PORTB = ((code>>2)&0x3c) | mode;			//RS,f[^o

	wait(5);	//5ms ԑ҂
}

/*==========================================================================
							LCD BYTE o(4bit)	
----------------------------------------------------------------------------
@4rbg[ĥ߁A8rbgf[^4rbgƉ4rbgɕďóB
==========================================================================*/
void LCDOut4(int rs, char code)
{
	char	mode;	//݃[h
	char	lb,hb;	//()4rbg,RSϐ


	if( rs )	mode = LCD_RS;	//f[^
	else		mode = 0x00;	//

	hb = ((code>>2)&0x3c) | mode;	//4rbg,RS
	lb = ((code<<2)&0x3c) | mode;	//4rbg,RS

	PORTB = mode;		//RSo
	PORTB = hb | LCD_E;	//RS,E,ʃf[^o
	asm("NOP");			//ԉ҂ 1TCN
	asm("NOP");			//ԉ҂ 1TCN
	PORTB = hb;			//RS,ʃf[^o

	PORTB = lb | LCD_E;	//RS,E,ʃf[^o
	asm("NOP");			//ԉ҂ 1TCN
	PORTB = lb;			//RS,ʃf[^o

	wait(5);	//5ms ԑ҂
}

/*==========================================================================
							LCD 								
==========================================================================*/

void InitLCD(void)
{
	wait(15);				// 15ms ԑ҂
	LCDOut8(0,0x30);		// @\ݒ ,8rbg[h
	LCDOut8(0,0x30);		// @\ݒ ,8rbg[h
	LCDOut8(0,0x30);		// @\ݒ ,8rbg[h

	LCDOut8(0,0x20);		// @\ݒ ,4rbg[hɈڍs

	LCDOut4(0,0x28);		// 4rbg[h ,2s ,5*7hbg
	LCDOut4(0,0x08);		// \It ,J[\It ,_ŃIt
	LCDOut4(0,0x0e);		// \I ,J[\I ,_ŃIt
	LCDOut4(0,0x06);		// J[\Eړ ,\Vtg

	LCDOut4(0,0x01);		// \NA
	LCDOut4(0,0x02);		// J[\1sڂ̐擪ɔzu
}

/*==========================================================================
								LCD NA									
==========================================================================*/
void ClearLCD(void)
{
	LCDOut4(0,0x01);	// \NA
	LCDOut4(0,0x02);	// J[\1sڂ̐擪ɔzu
}

/*==========================================================================
							LCDLN^\								
----------------------------------------------------------------------------
'\n'1sڂ2sڂ։s,'\r'̓J[\1sڂ̐擪ɔzu,'\f'LCDNA
sB
==========================================================================*/
void PutLCD(char c)
{
	if( c == '\f' )			ClearLCD();		//LCDNA
	else if( c == '\n' )	LocateLCD(0,1);	//s
	else if( c == '\r' )	LCDOut4(0,0x2);	//J[\z[
	else 					LCDOut4(1,c);	//LN^\
}

/*==========================================================================
							LCDJ[\ړ									
----------------------------------------------------------------------------
	x = 0`15																
	y = 0,1																	
	j1sڂ̐擪̍WF(x,y)=(0,0)
==========================================================================*/
void LocateLCD(int x,int y)
{
	LCDOut4(0,0x80 + y*0x40 + x);	//LCD BYTE o(4bit)
}

/*==========================================================================
							LCD\
----------------------------------------------------------------------------
char^z̔z񖼂ɓƁA̔z̐擪I܂łLCDɏo
Bz̏Iɂ͕̏I0x00Ă邱ƁB
==========================================================================*/
void PrintLCD(char *str)
{
	while ( *str )		//|C^̓e0x00ɂȂ܂ŌJԂ
		PutLCD(*str++);	//LCDLN^\
}
